package CheckEval;
use strict;

sub getProperties($$$) {
    my ($io, $target_record_id, $target_state_id) = @_;
    while (my $line = $io->getline()) {
	my ($record_id, $state_id, @properties) = split(/\s+/, $line);
	next
	    unless ($record_id == $target_record_id)
		&& ($state_id == $target_state_id);
	return @properties;
    }
    die "oops";
}

sub makeBlackStand (@) {
    my @properties = @_;
    my $result;
    foreach my $i (0..6) {
	$result.=$properties[$i]." ";
    }
    return $result;
}

sub makeBinaryBlackStand (@) {
    my @properties = @_;
    my $result;
    foreach my $i (0..6) {
	$result.=($properties[$i] ? "1" : "0")." ";
    }
    return $result;
}

sub makeWhiteCastleEffect (@) {
    my @properties = @_;
    my $result = "";
    foreach my $i (32..47) {
	next
	    if (($i % 2) == 0);
	$result.=($properties[$i] ? "1" : "0")." ";
    }
    return $result;
}

my @kingOccur;
sub makeWhiteKingPosition (@) {
    my @properties = @_;
    #  14
    #  31
    my $kingPosition = $properties[31];
    $kingPosition = 0		# ¾
	if (($kingPosition % 10) >= 6);
    my $result = "";
    foreach my $i (0, 11..99) {	# 2/7 0 ϼnextƤޤ̵̣Ǥʤ
	next
	    if (($i % 10) == 0);
	next
	    if (($i % 10) >= 6);
	$result .= (($kingPosition == $i) ? "1" : "0")." ";
    }
    $kingOccur[$kingPosition]++;
    return $result;
}

# 3x3 Τɤξ꤫ޤ
my %castleOccur;
sub makeWhiteCastle (@) {
    # king ͤʤΩˤϤǤʤ
    my @properties = @_;
    my $result = "";
    foreach my $i (32..47) {
	next
	    if (($i % 2) == 1);
	my $ptypeo = $properties[$i];
	my $written = 0;
	foreach my $j (0..29) {
	    if ($j == $ptypeo) {
		$result .= "1 ";
		$written++;
	    } else {
		$result .= "0 ";
	    }
	}
	die "not found? $written"
	    unless $written == 1;
	$castleOccur{$ptypeo."-".(($i-32)/2)}++;
    }
    return $result;
}

# 3x3 ϴޤޤ
my @castlePiecesOccur;
sub makeWhiteCastlePieces (@) {
    # king ͤʤΩˤϤǤʤ
    my @properties = @_;
    my @pieces;
    my $result = "";
    foreach my $i (32..47) {
	next
	    if (($i % 2) == 1);
	my $ptypeo = $properties[$i];
	$pieces[$ptypeo]++;
    }
    foreach my $j (0..29) {
	if ($pieces[$j]) {
	    $result .= "$pieces[$j] ";
	    $castlePiecesOccur[$j]++;
	} else {
	    $result .= "0 ";
	}
    }
    return $result;
}

END {
    foreach my $i (0, 11..99) {
	next
	    unless ($kingOccur[$i]);
	print STDERR "$i $kingOccur[$i]\n"
	    if ($kingOccur[$i] < 20);
    }
    foreach my $keys (sort keys %castleOccur) {
	print STDERR "$keys $castleOccur{$keys}\n"
	    if ($castleOccur{$keys} < 20);
    }
    foreach my $i (0..29) {
	$castlePiecesOccur[$i] = 0
	    unless ($castlePiecesOccur[$i]);
	print STDERR "$i $castlePiecesOccur[$i]\n"
	    if ($castlePiecesOccur[$i] < 20);
    }
}
###
1;
